<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <title>Task 30.35</title>
  </head>
  <body>
    <div class="container">
      <div class="row">
        <div class="jumbotron signup-form col-sm-6 mx-auto">
          <div class="form-group">
            <h2>Sign Up</h2>
          </div>
          <div class="form-group">
            <p class="hint-text">Please fill in this form to create account</p>
          </div>
          <div class="form-group"><hr /></div>
          <div class="form-group">
            <div class="row">
              <div class="col">
                <input
                  type="text"
                  class="form-control"
                  id="inp-first-name"
                  placeholder="First Name"
                />
              </div>
              <div class="col">
                <input
                  type="text"
                  class="form-control"
                  id="inp-last-name"
                  placeholder="Last Name"
                />
              </div>
            </div>
          </div>
          <div class="form-group">
            <input
              type="email"
              class="form-control"
              id="inp-email"
              placeholder="Email"
            />
          </div>
          <div class="form-group">
            <input
              type="password"
              class="form-control"
              id="inp-password"
              placeholder="Password"
            />
          </div>
          <div class="form-group">
            <input
              type="password"
              class="form-control"
              id="inp-confirm-password"
              placeholder="Confirm Password"
            />
          </div>
          <div class="form-group">
            <input type="checkbox" id="check-confirm-accept" />I accept the
            <a href="#">Terms of Use</a> &amp;
            <a href="#">Privacy Policy</a>
            <p id="p-agree-feedback" class="invalid-feedback">
              You must accept before submitting
            </p>
          </div>
          <div class="form-group">
            <button id="btn-sign-up" class="btn btn-primary btn-lg">
              Sign Up
            </button>
          </div>
        </div>
      </div>
    </div>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      var gEleFirstName = $("#inp-first-name");
      var gEleLastName = $("#inp-last-name");
      var gEleEmail = $("#inp-email");
      var gElePassword = $("#inp-password");
      var gEleConfirmPass = $("#inp-confirm-password");
      var gEleAcceptCheck = $("#check-confirm-accept");

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      $(document).ready(function () {
        $("#btn-sign-up").on("click", onBtnSignUpClick);
      });

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      //hàm xử lý khi bấm nút sign up
      function onBtnSignUpClick() {
        ("use strict");
        //khai báo object
        var vUserObj = {
          firstname: "",
          lastname: "",
          email: "",
          password: "",
          confirmpassword: "",
          iAccept: false,
        };

        //b1: đọc
        getFormInputData(vUserObj);

        //b2: kiểm tra
        var vIsValid = validateForm(vUserObj);
        //b3: xử lý hiển thị
        if (vIsValid) {
          showDataInConsole(vUserObj);
        }
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //hàm đọc dữ liệu
      function getFormInputData(paramUserDataObj) {
        paramUserDataObj.firstname = gEleFirstName.val();
        paramUserDataObj.lastname = gEleLastName.val();
        paramUserDataObj.email = gEleEmail.val();
        paramUserDataObj.password = gElePassword.val();
        paramUserDataObj.confirmpassword = gEleConfirmPass.val();
        paramUserDataObj.iAccept = gEleAcceptCheck.is(":checked");
      }

      //hàm kiểm tra dữ liệu
      function validateForm(paramUserDataObj) {
        var vRegexStr = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        if (paramUserDataObj.firstname == "") {
          alert("chưa nhập first name ...!");
          return false;
        }
        if (paramUserDataObj.lastname == "") {
          alert("chưa nhập last name ...!");
          return false;
        }
        if (paramUserDataObj.email == "") {
          alert("chưa nhập email ...!");
          return false;
        }
        if (!vRegexStr.test(paramUserDataObj.email)) {
          alert("email đã nhập không hợp lệ ...!");
          return false;
        }
        if (paramUserDataObj.password == "") {
          alert("chưa nhập password!");
          return false;
        }
        if (paramUserDataObj.password != paramUserDataObj.confirmpassword) {
          alert("Confirm password không khớp. Kiểm tra lại!");
          return false;
        }
        if (!paramUserDataObj.iAccept) {
          $("#p-agree-feedback").css("display", "block");
          alert("You must accept before submitting");
          return false;
        } else {
          $("#p-agree-feedback").css("display", "none");
        }
        return true;
      }

      //hàm ghi thông tin ra console
      function showDataInConsole(paramUserDataObj) {
        console.log("Firstname: " + paramUserDataObj.firstname);
        console.log("Lastname: " + paramUserDataObj.lastname);
        console.log("email: " + paramUserDataObj.email);
        console.log("password: " + paramUserDataObj.password);
        console.log("confirmpassword: " + paramUserDataObj.confirmpassword);
        console.log("I accept: " + paramUserDataObj.iAccept);
      }
    </script>
  </body>
</html>
